"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@tangential/core");
//noinspection TypeScriptPreferShortImport
var number_ival_1 = require("../../data-type/number/number-ival");
var input_view_mode_1 = require("../../support/input-view-mode");
var icon_rating_widget_config_1 = require("./icon-rating-widget-config");
var IconRatingWidgetTemplateComponent = (function () {
    function IconRatingWidgetTemplateComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.mode = input_view_mode_1.InputViewModes.VIEW;
        this.change = new core_1.EventEmitter(false);
        this.viewModes = input_view_mode_1.InputViewModes;
    }
    IconRatingWidgetTemplateComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    IconRatingWidgetTemplateComponent.prototype.emitChangeEvent = function () {
        this.change.emit();
    };
    return IconRatingWidgetTemplateComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], IconRatingWidgetTemplateComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], IconRatingWidgetTemplateComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], IconRatingWidgetTemplateComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", icon_rating_widget_config_1.IconRatingWidgetConfig
    /* Support for dynamic use. */
    )
], IconRatingWidgetTemplateComponent.prototype, "config", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", number_ival_1.NumberIval)
], IconRatingWidgetTemplateComponent.prototype, "ival", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], IconRatingWidgetTemplateComponent.prototype, "mode", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetTemplateComponent.prototype, "change", void 0);
IconRatingWidgetTemplateComponent = __decorate([
    core_1.Component({
        selector: 'tanj-icon-rating-widget-template',
        template: "\n                   <ng-container *ngIf=\"mode == viewModes.VIEW || mode == viewModes.PREVIEW || mode == viewModes.EDIT  \">\n                     <tanj-icon-rating-widget\n                       [labelPosition]=\"config.labelPosition\"\n                       [disabled]=\" mode == viewModes.PREVIEW || config.disabled\"\n                       [(value)]=\"ival.value\"\n                       [label]=\"config.label\"\n                       [defaultValue]=\"config.typeConfig.defaultValue\"\n                       [max]=\"config.typeConfig.max\"\n                       [iconFont]=\"config.iconFont\"\n                       [offIconNames]=\"config.offIconNames\"\n                       [onIconNames]=\"config.onIconNames\">\n                     </tanj-icon-rating-widget>\n                   </ng-container>\n                   <ng-container *ngIf=\"mode == viewModes.CONFIGURE\">\n                     <tanj-icon-rating-widget-configure\n                       [labelPosition]=\"config.labelPosition\"\n                       [disabled]=\"config.disabled\"\n                       [(value)]=\"ival.value\"\n                       [(label)]=\"config.label\"\n                       [(defaultValue)]=\"config.typeConfig.defaultValue\"\n                       [(max)]=\"config.typeConfig.max\"\n                       [(iconFont)]=\"config.iconFont\"\n                       [(offIconNames)]=\"config.offIconNames\"\n                       [(onIconNames)]=\"config.onIconNames\">\n                     </tanj-icon-rating-widget-configure>\n                   </ng-container>\n                 ",
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], IconRatingWidgetTemplateComponent);
exports.IconRatingWidgetTemplateComponent = IconRatingWidgetTemplateComponent;

//# sourceMappingURL=icon-rating-widget.template.component.js.map
